package owg.lgm.gl;

public class AttribArray
{
	public final BufferObject vertexBufferObject;	
	public final VertexAttribute attrib;
	
	public final int elementCount;
	public final DataType dataType;
	public final int byteStride;
	public final long byteOffset;
	
	public AttribArray(BufferObject vbo, VertexAttribute attrib, int elementCount, DataType dataType, int byteStride, long byteOffset)
	{
		this.vertexBufferObject = vbo;
		this.attrib = attrib;
		assert elementCount >= 0 && elementCount <= 4 : "Invalid elementCount: "+elementCount;
		this.elementCount = elementCount;
		this.dataType = dataType;
		this.byteStride = byteStride;
		this.byteOffset = byteOffset;
	}
	
	protected AttribArray()
	{
		this.vertexBufferObject = null;
		this.attrib = null;
		this.elementCount = 0;
		this.dataType = null;
		this.byteStride = 0;
		this.byteOffset = 0;
	}
}