package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL2ES1;

public enum BufferUsage
{
	STATIC_DRAW(GL2ES1.GL_STATIC_DRAW), 
	DYNAMIC_DRAW(GL2ES1.GL_DYNAMIC_DRAW);

	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(BufferUsage v : values())
			map.put(v.value, v);
	}
	public static BufferUsage of(int glUsage) throws IllegalArgumentException
	{
		BufferUsage r = (BufferUsage) map.get(glUsage);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized usage enum: "+glUsage+" ("+Integer.toHexString(glUsage)+")");
		return r;
	}
    public final int value;

    BufferUsage(int value)
    {
        this.value = value;
    }
}
