package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL2ES1;

public enum DataType
{
    UNSIGNED_BYTE(GL2ES1.GL_UNSIGNED_BYTE, 1),
    BYTE(GL2ES1.GL_BYTE, 1),
    UNSIGNED_SHORT(GL2ES1.GL_UNSIGNED_SHORT, 2),
    SHORT(GL2ES1.GL_SHORT, 2),
    UNSIGNED_INT(GL2ES1.GL_UNSIGNED_INT, 4),
    FLOAT(GL2ES1.GL_FLOAT, 4),   
    UNSIGNED_SHORT_5_6_5(GL2ES1.GL_UNSIGNED_SHORT_5_6_5, 2),
    UNSIGNED_SHORT_4_4_4_4(GL2ES1.GL_UNSIGNED_SHORT_4_4_4_4, 2),
    UNSIGNED_SHORT_5_5_5_1(GL2ES1.GL_UNSIGNED_SHORT_5_5_5_1, 2),
    UNSIGNED_INT_24_8(GL2ES1.GL_UNSIGNED_INT_24_8, 4),
    UNSIGNED_INT_10F_11F_11F_REV(GL2ES1.GL_UNSIGNED_INT_10F_11F_11F_REV, 4);

	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(DataType v : values())
			map.put(v.value, v);
	}
	public static DataType of(int glType) throws IllegalArgumentException
	{
		DataType r = (DataType) map.get(glType);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized data type enum: "+glType+" ("+Integer.toHexString(glType)+")");
		return r;
	}

	public static String toString(int glType)
	{
		DataType r = (DataType) map.get(glType);
		if(r == null)
			return glType+" (0x"+Integer.toHexString(glType)+")";
		return r.name();
	}
	
    public final int value;
    public final int size;

    DataType(int value, int size)
    {
        this.value = value;
        this.size = size;
    }
}