package owg.lgm.gl;

import com.jogamp.opengl.GL2ES1;

public class RenderBuffer extends GLResource
{
	public final RenderBufferFormat format;
	public final int width, height;
	
	protected transient GL2ES1 gl;
	protected transient int handle;
	
	public RenderBuffer(GL2ES1 gl, RenderBufferFormat format, int width, int height)
	{
		this.format = format;
		this.width = width;
		this.height = height;
		init(gl);
	}
	
	protected RenderBuffer() 
	{
		format = null;
		width = 0;
		height = 0;
	}

	@Override
	public int getInitOrder() {
		return 0;
	}

	@Override
	public void init(GL2ES1 gl)
	{
		this.gl = gl;
		{
			int[] r = new int[1];
			gl.glGenRenderbuffers(1, r, 0);
			handle = r[0];
		}
		gl.glBindRenderbuffer(GL2ES1.GL_RENDERBUFFER, handle);
		gl.glRenderbufferStorage(GL2ES1.GL_RENDERBUFFER, format.value, width, height);
		gl.glBindRenderbuffer(GL2ES1.GL_RENDERBUFFER, 0);
	}
	
	public int getHandle()
	{
		return handle;
	}

	@Override
	public void uninit()
	{
		gl.glDeleteRenderbuffers(1, new int[] {handle}, 0);
		handle = 0;
	}

}
