package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL2ES1;

public enum TexFormat
{
	LUMINANCE(GL2ES1.GL_LUMINANCE, GL2ES1.GL_LUMINANCE, 1, DataType.UNSIGNED_BYTE),
	ALPHA(GL2ES1.GL_ALPHA, GL2ES1.GL_ALPHA, 1, DataType.UNSIGNED_BYTE),
	LUMINANCE_ALPHA(GL2ES1.GL_LUMINANCE_ALPHA, GL2ES1.GL_LUMINANCE_ALPHA, 1, DataType.UNSIGNED_BYTE),
	RGB(GL2ES1.GL_RGB, GL2ES1.GL_RGB, 3, DataType.UNSIGNED_BYTE),
	RGBA(GL2ES1.GL_RGBA, GL2ES1.GL_RGBA, 4, DataType.UNSIGNED_BYTE);
	
	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(TexFormat v : values()) {
			map.put(v.sizedFormat, v);
			map.put(v.baseFormat, v);
		}
	}
	public static TexFormat of(int glFormat) throws IllegalArgumentException
	{
		TexFormat r = (TexFormat) map.get(glFormat);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized sized format enum: "+glFormat+" ("+Integer.toHexString(glFormat)+")");
		return r;
	}
    
    public final int sizedFormat;
    public final int baseFormat;
    public final int byteCount;
    public final DataType dataType;

	TexFormat(int sizedFormat, int baseFormat, int byteCount, DataType dataType)
    {
        this.sizedFormat = sizedFormat;
        this.baseFormat = baseFormat;
        this.byteCount = byteCount;
        this.dataType = dataType;
    }
}
