package owg.lgm.gl;

public class TexSampler
{
	public static final TexSampler REPEAT = new TexSampler(MinFilter.LINEAR, MagFilter.NEAREST, Wrap.REPEAT, Wrap.REPEAT, Wrap.REPEAT, 0.0f);
	public static final TexSampler CLAMP = new TexSampler(MinFilter.LINEAR, MagFilter.NEAREST, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, 0.0f);
	public static final TexSampler NEAREST_REPEAT = new TexSampler(MinFilter.NEAREST, MagFilter.NEAREST, Wrap.REPEAT, Wrap.REPEAT, Wrap.REPEAT, 0.0f);
	public static final TexSampler NEAREST_CLAMP = new TexSampler(MinFilter.NEAREST, MagFilter.NEAREST, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, 0.0f);
	public static final TexSampler LINEAR_REPEAT = new TexSampler(MinFilter.LINEAR, MagFilter.LINEAR, Wrap.REPEAT, Wrap.REPEAT, Wrap.REPEAT, 0.0f);
	public static final TexSampler LINEAR_CLAMP = new TexSampler(MinFilter.LINEAR, MagFilter.LINEAR, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, Wrap.CLAMP_TO_EDGE, 0.0f);
	
	public final Wrap wrapS, wrapT, wrapR;
	public final MinFilter minFilter;
	public final MagFilter magFilter;
	public final float maxAnisotropy;

	public TexSampler(MinFilter minFilter, MagFilter magFilter, Wrap wrapS, Wrap wrapT)
	{
		this(minFilter, magFilter, wrapS, wrapT, Wrap.REPEAT, 0.0f);
	}
	public TexSampler(MinFilter minFilter, MagFilter magFilter, Wrap wrapS, Wrap wrapT, Wrap wrapR)
	{
		this(minFilter, magFilter, wrapS, wrapT, wrapR, 0.0f);
	}
	public TexSampler(MinFilter minFilter, MagFilter magFilter, Wrap wrapS, Wrap wrapT, Wrap wrapR, float maxAnisotropy)
	{
		this.minFilter = minFilter;
		this.magFilter = magFilter;
		this.wrapS = wrapS;
		this.wrapT = wrapT;
		this.wrapR = wrapR;
		this.maxAnisotropy = maxAnisotropy;
	}
}
