package owg.lgm.gl;

import java.nio.FloatBuffer;

import com.jogamp.opengl.GL2ES1;

public class VertexBufferObject extends BufferObject
{
	protected FloatBuffer data;
	
	public VertexBufferObject(GL2ES1 gl, FloatBuffer data, BufferUsage usage)
	{
		super(GL2ES1.GL_ARRAY_BUFFER, data.position(), data.limit(), usage);
		this.data = data;
		init(gl);
	}
	
	protected VertexBufferObject() {
		super(GL2ES1.GL_ARRAY_BUFFER, 0, 0, null);
	}
	
	@Override
	public FloatBuffer getData()
	{
		return data;
	}
	
	public void setData(FloatBuffer data)
	{
		this.data = data;
		this.eOffset = data.position();
		this.eSize = data.remaining();
		replace();
	}
}
