package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL2ES1;

public enum Wrap
{
    CLAMP_TO_EDGE(GL2ES1.GL_CLAMP_TO_EDGE),
    MIRRORED_REPEAT(GL2ES1.GL_MIRRORED_REPEAT),
    REPEAT(GL2ES1.GL_REPEAT);
	
	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(Wrap v : values())
			map.put(v.value, v);
	}
	public static Wrap of(int glTextureWrap) throws IllegalArgumentException
	{
		Wrap r = (Wrap) map.get(glTextureWrap);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized minification filter enum: "+glTextureWrap+" ("+Integer.toHexString(glTextureWrap)+")");
		return r;
	}

    public final int value;

    Wrap(int value)
    {
        this.value = value;
    }
}
