package owg.lgm.plaf;

import owg.lgm.util.FILE;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class JAVAFILE implements FILE
{
	public final File file;
	
	public JAVAFILE(String fname)
	{
		file = new File(Engine.EN.dir, fname);
	}
	protected JAVAFILE(File file)
	{
		this.file = file;
	}
	public JAVAFILE(JAVAFILE dir, String child)
	{
		this.file = new File(dir.file, child);
	}

	public boolean exists()
	{
		return file.exists();
	}

	@Override
	public String getPath()
	{
		return file.getPath();
	}

	@Override
	public String getName()
	{
		return file.getName();
	}

	@Override
	public JAVAFILE getParentFile()
	{
		return new JAVAFILE(file.getParentFile());
	}
	
	@Override
	public void mkdirs()
	{
		file.mkdirs();
	}

	@Override
	public InputStream read() throws FileNotFoundException
	{
		return new FileInputStream(file);
	}
	
	@Override
	public OutputStream write() throws FileNotFoundException
	{
		return new FileOutputStream(file);
	}
	
	@Override
	public boolean delete()
	{
		return file.delete();
	}
	@Override
	public byte[] getBytes() throws IOException
	{
		try(InputStream in = read())
		{
			ByteArrayOutputStream data = new ByteArrayOutputStream(4096);
			byte[] buf = new byte[4096];
			int r;
			while((r=in.read(buf))>0)
				data.write(buf, 0, r);
			return data.toByteArray();
		}
	}
	public boolean isDirectory()
	{
		return file.isDirectory();
	}
	
	@Override
	public FILE[] listFiles() throws IOException
	{
		File[] fs = file.listFiles();
		if(fs == null)
			throw new IOException("Failed to list files in: "+this);
		FILE[] r = new FILE[fs.length];
		for(int i = 0; i<r.length; i++)
			r[i] = new JAVAFILE(fs[i]);
		return r;
	}
	
	@Override
	public String toString()
	{
		return getPath();
	}
	@Override
	public boolean isFile()
	{
		return file.isFile();
	}
	@Override
	public FILE getChild(String page)
	{
		return new JAVAFILE(this, page);
	}
}
