package owg.lgm.util;

import owg.util.iorderset.IOrderHashSet;

public class AutoDestructibleImpl extends DestructibleImpl implements AutoDestructible
{
	protected final IOrderHashSet<Destructible> autoDestructibles = new IOrderHashSet<>();
	
	@Override
	public void autoDestroy(Destructible d)
	{
		autoDestructibles.add(d);
	}

	@Override
	public void dispose()
	{
		if(!destroyed)
		{
			for(Destructible d : autoDestructibles)
				d.dispose();
			destroyed = true;
		}
	}
}
