package owg.competent;

public enum DSPErrorCode
{
	NO_ERROR("No error"), 
	FREEZE("Execution paused since we hit the maximum instructions"),				 
	UNKNOWN_OPCODE("unknown opcode"),
	UNSUPPORTED_OPCODE("Instruction not supported on this platform"),
	INVALID_REGISTER("Invalid register access"),
	ERROR_INTERRUPT("An error occurred while processing an interrupt"),
	STACK_OVERFLOW("Stack overflow"),
	STACK_UNDERFLOW("Stack underflow"), 
	INVALID_ADDRESS("Tried to access an invalid memory address"),
	RETURNED_ERROR("Program returned an error code or bad value");
	
	public final String description;
	
	DSPErrorCode(String description)
	{
		this.description = description;
	}
	
	@Override
	public String toString() {
		return ordinal()+": "+description;
	}
}
