package owg.competent;
/**Sample formats supported by Competent Audio.
 * When loading a clip using the enqueueClip function, the format of the sample data must be specified.
 * CA works with native-endian 32 bit floating point samples internally, and performs the necessary conversions on the fly.*/
public enum SampleFormat
{
	FLOAT32(4),
	INT32(4),
	INT24(3),
	INT16(2),
	INT8(1),
	UINT8(1);
	
	/**The size of a single sample in bytes.*/
	public final int sizeInBytes;
	private SampleFormat(int sizeInBytes)
	{
		this.sizeInBytes = sizeInBytes;
	}
}
